package reasoner;

import reasoner.grounding.IntervalProvider;
import reasoner.io.DatabaseManager;
import reasoner.lineage.LineageArray;
import reasoner.lineage.providers.LineageProvider;

public class ReasonerConfig {
	
	// enables more error checking
  // for measuring runtimes set to false
  public static final boolean debugMode = false;
  
  // If set to Integer.Max_Value no disjointOr are created.
  // Otherwise disjointOrs are created till each lineage node
  // has less than @maxShannonPerNode shannon variables.
  public static final int maxShannonPerNode = 1;
  
  public static final boolean useLineagePreprocessing = true;
	
	public static void clearAll() throws Exception {
		// return all lineage
		LineageArray.getInstance().clearAll();
		
		// Sanity checks
		IntervalProvider.getInstance().allObjectsReturned();
		LineageProvider.getInstance().allObjectsReturned();
		
		// clean up DB
		DatabaseManager.getInstance().clearDBall();
	}
}
