package reasoner.io.loader;

import reasoner.io.DatabaseManager;
import reasoner.io.dataset.Dataset;

/**
 * Run this if you want to alter the confidences of an existing dataset.
 * 
 * learned confidences file should have the columns:
 * array_id tab confidence [tab optional_data]
 *
 */
public class RunConfidenceLoader {
	public static void main(String[] args) throws Exception {	
		if (args.length != 2) {
			System.err.println("Required argument: dataset_name path_to_learned_confidences.tsv");
			return;
		}
		
		DatabaseManager dbManager = DatabaseManager.getInstance();
		Dataset dataset = dbManager.getDataset(args[0]);
		dataset.writeConfidencesToDatabase(args[1]);
	}
}
