package reasoner.io.loader;

import java.util.Set;

//import reasoner.ReasonerConfig;

import util.io.Paths;

public class RunDatasetLoader {

	/**
	 * Run this if you want to load a dataset into database.
	 * 
	 * relation definition file:
	 * relationName tab numberOfNonTemporalArguments tab certain tab temporalBegin tab temporalEnd
	 * 
	 * folder with relations contains: relationName.tsv files
	 */
	public static void main(String[] args) throws Exception {	
		if (args.length != 3) {
			System.err.println("Required arguments: dataset_name path_to_relation_definition.tsv folder_with_relations");
			return;
		}
		args[2] = Paths.removeSlash(args[2]);
		//if (!ReasonerConfig.debugMode) {
		//	throw new Exception("Please enable debug mode for loading");
		//}
		
		TupleParser parser = new TupleParser();
		parser.createDataset(args[0]);
		Set<String> relationNames = parser.parseRelations(args[1]);
		for (String relationName : relationNames) {
			System.out.println("loading " + relationName);
			parser.parseTuplesForRelation(args[2] + "/" + relationName + ".tsv", "\t", relationName);
		}
		parser.parsingFinished();
	}
}
