package reasoner.lineage;

import reasoner.ReasonerConfig;

public class LineageLeaf extends Lineage {
	public double conf;
	public int id;
	
	public LineageLeaf(){
		super();
	}
	
	public void setVar(int id, double conf) {
	  if (ReasonerConfig.debugMode) {
	    if (id < 0) {
	      System.err.println("Invalid variable id in LineageLeaf " + id);
	      return;
	    }
	  }
	  this.conf = conf;
	  this.id = id;
	  this.vars.add(id);
	}
	
	@Override
	public void acceptVisitor(LineageVisitor visitor) throws Exception {
		visitor.visit(this);
	}
	
	@Override
	public void clear() {
	  super.clear();
	  conf = -1.0;
	  id = -1;
	}
	
	public String name(){
		return this.conf + "";
	}
}
