package reasoner.lineage.providers;

import reasoner.ReasonerConfig;
import reasoner.lineage.Lineage;
import reasoner.lineage.LineageDisjointOr;
import reasoner.lineage.LineageLeaf;
import util.provider.AbstractProvider;

public class LineageDisjointOrProvider extends AbstractProvider<LineageDisjointOr> {

	public LineageDisjointOrProvider() throws Exception {
		super(LineageDisjointOrProvider.class.getName(), 1024);
	}
	
	@Override
	protected LineageDisjointOr getNew() {
		return new LineageDisjointOr();
	}

	public LineageDisjointOr get(Lineage childPos, Lineage childNeg, LineageLeaf var) throws Exception {
		if (ReasonerConfig.debugMode) {
			if (childPos.vars.contains(var.id)) {
				throw new Exception("pos cannot contain the variable we are ind on");
			}
			if (childNeg.vars.contains(var.id)) {
				throw new Exception("neg cannot contain the variable we are ind on");
			}
		}
		LineageDisjointOr toReturn = getCleanObject();
		toReturn.setNewChildren(childPos, childNeg);
		toReturn.setVarId(var);
		return toReturn;
	}
}
