package reasoner.lineage.providers;

import reasoner.lineage.Lineage;
import reasoner.lineage.LineageOr;
import reasoner.lineage.shannonmaterializer.ShannonMaterializerProvider;

public class LineageOrProvider extends AbstractLineageProvider<LineageOr> {
  
  public LineageOrProvider(LineageProvider provider, ShannonMaterializerProvider shannonMaterializerProvider) throws Exception {
    super(LineageOrProvider.class.getName(), 1024, provider, shannonMaterializerProvider);
  }

  @Override
  protected LineageOr getNew() {
    return new LineageOr();
  }

  public Lineage get(Lineage... children) throws Exception {
    LineageOr toReturn = getCleanObject();
    toReturn.setNewChildren(children);
    return split(toReturn);
  }
}
