package reasoner.lineage.shannonmaterializer;

import reasoner.lineage.providers.LineageProvider;
import util.provider.AbstractProvider;

public class ShannonMaterializerProvider extends AbstractProvider<ShannonMaterializer> {
	
	private LineageProvider lineageProvider;
	
	public ShannonMaterializerProvider(LineageProvider lineageProvider) throws Exception {
		super(ShannonMaterializer.class.getName(), 4);
		this.lineageProvider = lineageProvider;
	}

	@Override
	protected ShannonMaterializer getNew() throws Exception {
		return new ShannonMaterializer();
	}

	public ShannonMaterializer getMaterializer() throws Exception {
		ShannonMaterializer toReturn = getCleanObject();
		toReturn.setLineageProvider(lineageProvider);
		return toReturn;
	}
}
