package reasoner.lineage.shannonmaterializer;

import reasoner.lineage.Lineage;
import util.provider.Providable;

/**
 * Stack Element for ShannonMaterializer
 * 
 * Encapsulates lineage and meta information.
 */
public class StackElement extends Providable {
	public Lineage lineage;
	public int depth;  // children of the lineage will have the same depth
	public boolean newLineage;  // used to detect, whether the lineage should be added to the lineageArray (so it will be garbage collected).
	
	@Override
	public void clear() {
		lineage = null;
		depth = -1;
		newLineage = true;
	}
}
