package reasoner.lineage.shannonmaterializer;

import reasoner.lineage.Lineage;
import util.provider.AbstractProvider;

/**
 * Provides StackElements for ShannonMaterializer.
 */
public class StackElementProvider extends AbstractProvider<StackElement> {
	
	public StackElementProvider(int initialSize) throws Exception {
		super(StackElement.class.getName(), initialSize);
	}
	
	@Override
	protected StackElement getNew() {
		return new StackElement();
	}
	
	public StackElement get(Lineage lineage, int depth, boolean newLineage) throws Exception {
		StackElement toReturn = getCleanObject();
		toReturn.lineage = lineage;
		toReturn.depth = depth;
		toReturn.newLineage = newLineage;
		return toReturn;
	}
}
