package reasoner.query.compiled;

import java.sql.ResultSet;

public class HeadArgument {
	//only one of the attributes is used
	private final String constant;  // constants
	private final int rsetId;  // variables
	
	public HeadArgument(String constant) {
		this.constant = constant;
		this.rsetId = -1;
	}
	
	public HeadArgument(int rsetId) {
		this.constant = null;
		this.rsetId = rsetId;
	}
	
	public String getArgument(ResultSet rset) throws Exception {
		if (constant != null) {
			return constant;
		} else {
			return rset.getString(rsetId);
		}
	}
}
