package reasoner.query.compiled;

import java.util.LinkedList;
import java.util.List;

import reasoner.io.dataset.Dataset;
import reasoner.io.dataset.Relation;

public class Query {
	public final QueryStep[] steps;
	public LinkedList<Relation> output;
	public final Dataset dataset;
	public final LinkedList<CompiledConstraint> constraints;
	public boolean useConstraints;
	public boolean dirty;
	public final LinkedList<String> constantsToSet;
	
	public Query(Dataset dataset, List<QueryStep> querySteps){
		dirty = false;
		output = new LinkedList<Relation>();
		constraints = new LinkedList<CompiledConstraint>();
		constantsToSet = new LinkedList<String>();
		this.dataset = dataset;
		steps = querySteps.toArray(new QueryStep[querySteps.size()]);
	}
}
