package reasoner.query.parsed;

import java.util.Collection;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

/**
 * Datastructure keeping the join order
 * along with the join variables.
 */
public class JoinOrdering {
	public List<Join> order;
	
	public JoinOrdering() {
		order = new LinkedList<Join>();
	}
	
	public void add(RelationalLiteral literal, Collection<Variable> variables) {
		order.add(new Join(literal, variables));
	}
	
	public class Join {
		public RelationalLiteral literal;
		public Set<Variable> variables;
		
		public Join(RelationalLiteral literal, Collection<Variable> variables) {
			this.literal = literal;
			this.variables = new HashSet<Variable>();
			this.variables.addAll(variables);
		}
	}
}
