package reasoner.weightlearning;

import reasoner.weightlearning.objective.L2labelsL2priorObjective;
//import reasoner.weightlearning.objective.LogicalObjective;
import reasoner.weightlearning.objective.WeightLearningObjective;

public class WeightLearningConfig {
	public static final int numRuns = 1;
	public static final int maxIterations = 100; 
	public static String resultPath;  // set to null to disable writing to disk
	public static final double relativeErrorBound = 1e-4;
	public static final double absoluteErrorBound = 1e-6;
	public static final boolean printing = false;
	public static WeightLearningObjective objective;  // only effective for SGS and SGD+PT
	public static final boolean multithreading = false;
	public static final double initialLearningRate = 1000.0;
	
	/*
	 * Choose optimization strategy here.
	 * 
	 * Available Options:
	 *		SGD+PT  Stochastic Gradient Descent with Per Tuple learning rate
	 *		SGD     Stochastic Gradient Descent
	 *		GD      Gradient Descent
	 */
	public static final String strategyName = "SGD+PT";
	
	public WeightLearningConfig(String resultPath) throws Exception {
		// only effective for SGD and SGD+PT
		objective = new L2labelsL2priorObjective();
		//objective = new LogicalObjective();
		WeightLearningConfig.resultPath = resultPath;
	}
}
