package reasoner.weightlearning.problem;

import gnu.trove.list.linked.TIntLinkedList;
import gnu.trove.set.hash.TIntHashSet;

/**
 * This class encapsulates a set of tupleIds whose labeled
 * formulas are overlapping.
 * Each two instances of this class hold independent partitions
 * of the tupleIds. Hence, they can be optimized in parallel.
 */
public class ComputationTask {
	public final TIntLinkedList tupleIds;
	public final TIntHashSet formulaIds;
	
	public ComputationTask() {
		tupleIds = new TIntLinkedList();
		formulaIds = new TIntHashSet();
	}
	
	public String toString() {
		return tupleIds.toString();
	}
}
