package reasoner.weightlearning.strategies;

import reasoner.weightlearning.problem.ProblemInstance;
import reasoner.weightlearning.strategies.learningrate.LearningRate;

public interface StochasticGradientDescentUpdater {
	public void init(ProblemInstance problem, LearningRate learningRate, TupleConfidenceState state) throws Exception;
	/**
	 * @return error at the end
	 */
	public double run() throws Exception;
	public double getIterations();
	public double getInitialError();
}
