package reasoner.weightlearning.strategies;

public interface WeightLearningOptimizer {
	/**
	 * Executes the weight learning optimization procedure.
	 * @return error
	 */
	public double run() throws Exception;
	
	/**
	 * get run time not including preprocessing
	 */
	public long getRunTime() throws Exception;
	public long getPreprocessingTime() throws Exception;
	public double getNumIterations() throws Exception;
	public double getInitialError() throws Exception;
}
