package tests.reasoner;

import org.junit.runner.RunWith;
import org.junit.runners.Suite;

import tests.reasoner.grounding.GrounderDbTest;
import tests.reasoner.grounding.IntervalLogicTest;
import tests.reasoner.grounding.IntervalProviderTest;
import tests.reasoner.grounding.IntervalTest;
import tests.reasoner.io.DatabaseManagerTest;
import tests.reasoner.io.QueryParserTest;
import tests.reasoner.io.TimeTest;
import tests.reasoner.lineage.LineageTest;
import tests.reasoner.lineage.providers.LineageProviderTest;
import tests.reasoner.lineage.shannonmaterializer.ShannonMaterializerTest;
import tests.reasoner.query.QueryExecuterTest;
import tests.reasoner.query.RunQueryTest;
import tests.reasoner.weightlearning.WeightLearningTest;
import tests.reasoner.weightlearning.problem.ProblemInstanceTest;
import tests.reasoner.weightlearning.strategies.StochasticGradientDescentTest;
import tests.util.ArraysTest;
import tests.util.CollectionsTest;
import tests.util.DoublesTest;
import tests.util.LogitTest;
import tests.util.MapsTest;
import tests.util.datastructures.StackTest;
import tests.util.datastructures.UnionFindTest;
import tests.util.datastructures.directedgraph.DepthFirstSearchTest;
import tests.util.time.TimerTest;

@RunWith(Suite.class)
@Suite.SuiteClasses({
        // is debug mode set?
        RunQueryTest.class,
  
				// test all providers first, so later we can be lazy and omit cleaning up
        IntervalProviderTest.class,
        LineageProviderTest.class,
        QueryExecuterTest.class,
        ShannonMaterializerTest.class,
        
        CollectionsTest.class,
        QueryParserTest.class,
        MapsTest.class,
        LogitTest.class,
        TimeTest.class,
        UnionFindTest.class,
        DatabaseManagerTest.class,
        IntervalTest.class,
        LineageTest.class,
        IntervalLogicTest.class,
        GrounderDbTest.class,
        StackTest.class,
        DoublesTest.class,
        ArraysTest.class,
        TimerTest.class,
        ProblemInstanceTest.class,
        StochasticGradientDescentTest.class,
        WeightLearningTest.class,
        DepthFirstSearchTest.class
})
public class TestSuite {
}
