package tests.reasoner.grounding;

import static org.junit.Assert.*;

import java.util.HashSet;

import org.junit.Before;
import org.junit.Test;

import reasoner.grounding.Interval;
import reasoner.grounding.IntervalProvider;

public class IntervalProviderTest {
  private IntervalProvider provider;
  
  @Before
  public void setUp() throws Exception {
    provider = IntervalProvider.getInstance();
  }
  
  @Test
  public void testUniqueAndReturn() throws Exception {
    HashSet<Interval> intervals = new HashSet<Interval>();
    for (int i = 0; i < provider.getInitialSize() * 3; i++) {
      intervals.add(provider.get(1, 2, 3));
    }
    
    // are the objects unique?
    assertTrue(intervals.size() == 3 * provider.getInitialSize());
    
    provider.handBack(intervals);
    
    assertTrue(provider.allObjectsReturned());
  }
}
