package tests.reasoner.grounding;

import static org.junit.Assert.*;

import org.junit.Test;

import reasoner.grounding.Interval;
import reasoner.grounding.IntervalProvider;

public class IntervalTest {

  @Test
  public void length() throws Exception {
    Interval interval = IntervalProvider.getInstance().get(10, 11, 0);
    assertEquals(interval.getLength(), 1);
  }
  
  @Test
  public void overlap() throws Exception {
    Interval interval = IntervalProvider.getInstance().get(10, 20, 0);
    assertEquals(0, getOverlapWith(interval, 0, 10));  // before
    assertEquals(0, getOverlapWith(interval, 20, 30));  // after
    assertEquals(10, getOverlapWith(interval, 0, 30));  // bigger
    assertEquals(5, getOverlapWith(interval, 10, 15));  // containedIn
    assertEquals(5, getOverlapWith(interval, 5, 15));  // overlap begin
    assertEquals(5, getOverlapWith(interval, 15, 25));  // overlap end
  }
  
  private int getOverlapWith(Interval interval, int begin, int end) throws Exception {
    return interval.getOverlap(IntervalProvider.getInstance().get(begin, end, 0));
  }
}
