package tests.util.datastructures;

import static org.junit.Assert.assertTrue;

import org.junit.Test;

import util.datastructures.Stack;

public class StackTest {
	
	@Test
	public void testPushPeekPop() throws Exception {
		Stack<Integer> stack = new Stack<Integer>(100);
		for (int i = 0; i < 300; i++) {
			stack.push(i);
		}
		for (int i = 299; i >= 0; i--) {
			assertTrue(stack.peek() == i);
			assertTrue(stack.pop() == i);
		}
		assertTrue(stack.isEmpty());
	}
	
	@Test
	public void testEmptyStack() throws Exception {
		Stack<Integer> stack = new Stack<Integer>(100);
		try {
			stack.pop();
			assertTrue(false);  // it should fail
		} catch (Exception e) {
			assertTrue(true);
		}
		try {
			stack.peek();
			assertTrue(false);  // it should fail
		} catch (Exception e) {
			assertTrue(true);
		}
	}
}
