package tests.util.datastructures;

import static org.junit.Assert.*;
import org.junit.Test;

import util.datastructures.MappedUnionFind;
import util.datastructures.UnionFind;

public class UnionFindTest {
  
  @Test
  public void oneSet() {
    UnionFind uf = new UnionFind(20);
    for (int i = 1; i < 20; i++) {
      uf.union(i - 1, i);
    }
    assertTrue(uf.numSets() == 1);
    int root = uf.find(0);
    for (int i = 1; i < 20; i++) {
      assertTrue(uf.find(i) == root);
    }
  }
  
  @Test
  public void singleSets() {
    UnionFind uf = new UnionFind(20);
    for (int i = 0; i < 20; i++) {
      assertTrue(uf.find(i) == i);
    }
  }
  
  @Test
  public void mappedSets() {
  	int[] ids = {10, 100};
  	MappedUnionFind muf = new MappedUnionFind(ids);
  	assertTrue(muf.find(10) == 10);
  	assertTrue(muf.find(100) == 100);
  	muf.union(10, 100);
  	assertTrue(muf.numSets() == 1);
  }
}
