package tests.util.datastructures.directedgraph;

import static org.junit.Assert.*;

import org.junit.Test;

import util.datastructures.directedgraph.DepthFirstSearch;
import util.datastructures.directedgraph.DirectedEdge;
import util.datastructures.directedgraph.Vertex;

public class DepthFirstSearchTest {

	@Test
	public void cycleFree() {
		Vertex[] vertices = new Vertex[5];
		for (int i = 0; i < 5; i++) {
			vertices[i] = new Vertex("vertex " + i);
		}
		
		// 0 <- 1 <- 2
		// 0 <- 3 <- 4
		new DirectedEdge(vertices[1], vertices[0]);
		new DirectedEdge(vertices[2], vertices[1]);
		new DirectedEdge(vertices[3], vertices[0]);
		new DirectedEdge(vertices[4], vertices[3]);
		
		DepthFirstSearch dfs = new DepthFirstSearch();
		assertFalse(dfs.hasCycle(vertices[0]));
	}
	
	@Test
	public void cycle() {
		Vertex[] vertices = new Vertex[5];
		for (int i = 0; i < 5; i++) {
			vertices[i] = new Vertex("vertex " + i);
		}
		
		// 0 <- 1 <- 2 <- 3 <- 4 <- 0
		new DirectedEdge(vertices[1], vertices[0]);
		new DirectedEdge(vertices[2], vertices[1]);
		new DirectedEdge(vertices[3], vertices[2]);
		new DirectedEdge(vertices[4], vertices[3]);
		new DirectedEdge(vertices[0], vertices[4]);
		
		DepthFirstSearch dfs = new DepthFirstSearch();
		assertTrue(dfs.hasCycle(vertices[0]));
	}
}
