package util;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

public class Maps<T, U> {

  /**
   * reverses a map
   * @throws Exception if new map has clashing keys
   */
  public Map<U, T> reverse(Map<T, U> toBeReversed) throws Exception {
    Map<U, T> result = new HashMap<U, T>();
    for (Entry<T, U> entry : toBeReversed.entrySet()) {
      if (result.containsKey(entry.getValue())) {
        throw new Exception("Reversed map is not unique: " + entry.getValue());
      }
      result.put(entry.getValue(), entry.getKey());
    }
    return result;
  }
}
