package util.datastructures;

/**
 * Implements a stack based on an array
 * @param <T> the type of object stored on the stack
 */
public class Stack<T> {

	private T[] stack;
	private int pointer;
	
	@SuppressWarnings("unchecked")
	public Stack(int initialSize) {
		stack = (T[])new Object[initialSize];
		pointer = -1;
	}
	
	public T peek() throws Exception {
		if (pointer < 0) {
			throw new Exception("peek() on empty stack");
		}
		return stack[pointer];
	}
	
	public T pop() throws Exception {
		if (pointer < 0) {
			throw new Exception("pop() on empty stack");
		}
		T toReturn = stack[pointer];
		stack[pointer] = null;
		pointer -= 1;
		return toReturn;
	}
	
	public boolean isEmpty() {
		return pointer == -1;
	}
	
	@SuppressWarnings("unchecked")
	public void push(T obj) {
		pointer += 1;
		if (pointer == stack.length) {
			T[] newArray = (T[])new Object[stack.length * 2];
			System.arraycopy(stack, 0, newArray, 0, stack.length);
			stack = newArray;
		}
		stack[pointer] = obj;
	}
}
