package util.datastructures.directedgraph;

import java.util.HashSet;
import java.util.Set;

public class DepthFirstSearch {
	private Set<Vertex> vertices;
	
	public boolean hasCycle(Vertex start) {
		vertices = new HashSet<Vertex>();
		boolean returnValue = hasCycleRecursively(start);
		vertices = null;
		return returnValue;
	}
	
	private boolean hasCycleRecursively(Vertex v) {
		for (DirectedEdge edge : v.incoming) {
			Vertex other = edge.from;
			if (vertices.contains(other)) {
				return true;  // a cycle is found
			}
			vertices.add(other);
			boolean returnValue = hasCycleRecursively(other);
			if (returnValue) {
				return true;
			}
			vertices.remove(other);
		}
		return false;
	}
}
