package util.io;

import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Scanner;

/**
 * encapsulates the mess of java reading a file line by line 
 */
public class FileScanner {
  
  private FileInputStream fstream;
  private InputStreamReader in;
  private Scanner scanner;
  
  /**
   * Opens the file.
   */
  public FileScanner(String path2file) throws Exception {
    fstream = new FileInputStream(path2file);
    in = new InputStreamReader(fstream, "UTF-8");  // t420, blade: extracted
    //in = new InputStreamReader(fstream);  // lap-15-06, blade: yago
    scanner  = new Scanner(in);
  }
  
  public boolean hasNextLine() {
  	return scanner.hasNextLine();
  }
  
  public String nextLine() throws Exception {
    return scanner.nextLine().trim();
  }
  
  /**
   * advances to the first line containing @token
   * throws an exception if no such line was found
   */
  public String nextLineContaining(String token) throws Exception {
  	do {
  		String nextLine = scanner.nextLine();
  		if (nextLine.contains(token)) {
  			return nextLine;
  		}
  	} while (scanner.hasNextLine());
  	throw new Exception("no line containing " + token + " was found");
  }
  
  /**
   * call when reading of file is finished
   */
  public void close() throws Exception {
    scanner.close();
    in.close();
    fstream.close();
  }
}
