package util.io;

import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;

public class FileWriter {
	private BufferedWriter writer;
	
	public FileWriter(String fileName, boolean append) throws Exception {
		writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(fileName, append), "UTF-8"));
	}
	
	public FileWriter(String fileName, String encoding) throws Exception {
		writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(fileName), encoding));
	}
	
	public FileWriter(String fileName) throws Exception {
		writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(fileName), "UTF-8"));
	}
	
	public void append(String string) throws Exception {
		writer.append(string);
	}
	
	public void append(StringBuffer buffer) throws Exception {
		writer.append(buffer);
	}
	
	public void flush() throws Exception {
		writer.flush();
	}
	
	public void close() throws Exception {
		writer.flush();
		writer.close();
		writer = null;
	}
}
