package util.io;

import java.io.File;
import java.io.FilenameFilter;

public class Files {
	public static boolean fileExists(String pathToFile) {
		File file = new File(pathToFile);
		return file.exists();
	}
	
	/**
	 * Opens all files in a directory matching a specific filter.
	 * 
	 * Example Filter:
	   new FilenameFilter() {
       public boolean accept(File dir, String filename) {
         return filename.endsWith(".txt");
       }
     }
	 */
	public static File[] getFilesInDirectory(String directoryPath, FilenameFilter filter){
  	File dir = new File(directoryPath);
  	return dir.listFiles(filter);
  }
}
