package util.rand;

public class Uniform {
	private static Uniform instance;
	
	private cern.jet.random.Uniform uniform;
	
	private Uniform() {
		uniform = new cern.jet.random.Uniform(0.0, 1.0, (int)System.currentTimeMillis());
	}
	
	public static Uniform getInstance() {
		if (instance == null) {
			instance = new Uniform();
		}
		return instance;
	}
	
	public double getDouble(double from, double to) {
		return uniform.nextDoubleFromTo(from, to);
	}
	
	public double getDouble() {
		return uniform.nextDouble();
	}
	
	public boolean getBoolean() {
		return uniform.nextBoolean();
	}
	
	/**
	 * @return random integer in [0, max)
	 */
	public int getInt(int max) {
		return uniform.nextIntFromTo(0, max - 1);
	}
	
	/**
	 * @return random integer in [min, max)
	 */
	public int getInt(int min, int max) {
		return uniform.nextIntFromTo(min, max - 1);
	}
}
